function [FIG,FIG_ENG,battANALOG,ATTIVA] = report_LL(rLL,m,NodoLoadLink,toolrif,...
    unitrif,datarif,contunit,Font_caption,Font_tools,siteID,DT,DT_ENG,FIG,FIG_ENG,...
    br,colonna4,status,ATTIVA,battANALOG,activeEN,conn,FileName)

fileID = fopen(FileName,'a');
fmt = '%s \r';
text = 'report_LL function started';
fprintf(fileID,fmt,text);

import mlreportgen.dom.*
import mlreportgen.report.*

% Make sure DOM is compilable
makeDOMCompilable()

if status(m,1) == 1
    if strcmp(char(colonna4(m+1,1)),'Analog Array') == 1 % cella Analog Link
        if ATTIVA == 1
            testo = Paragraph('GMUX non ancora installato o canale inattivo.');
            add(DT,testo);
            ATTIVA = 0;
            if activeEN == 1
                testo = Paragraph('GMUX not installed or inactive.');
                add(DT_ENG,testo);
            end
        end
    else
        if ATTIVA == 1
            testo = Paragraph('Catena non ancora installata o inattiva.');
            ATTIVA = 0;
            add(DT,testo);
            if activeEN == 1
                testo = Paragraph('Array not installed or inactive.');
                add(DT_ENG,testo);
            end
        end
    end
elseif status(m,1) == 3
    if ATTIVA == 1
        testo = Paragraph(['Monitoraggio completato. Invitiamo a visitare la '...
            'piattaforma web per la visione dei dati storici.']);
        ATTIVA = 0;
        add(DT,testo);
        if activeEN == 1
            testo = Paragraph(['Monitoring completed. Please log into the web-based platform '...
                'to access the complete dataset.']);
            add(DT_ENG,testo);
        end
    end
else
     if strcmp(char(colonna4(m+1,1)),'Analog Array') == 1 % cella Analog Link
        if battANALOG == 0
            comando = ['select Date, Time, UnitName, ToolNameID, BatLevel, Temperature from RawDataView where Date >= ''' ...
                datarif ''' and UnitName = ''' char(unitrif) ''' and ToolNameID = '''...
                char(toolrif) ''' and NodeNum = 1 '];
            curs = exec(conn,comando);
            curs = fetch(curs);
            BatTemp = curs.Data;
            [~,cc] = size(BatTemp);
            if cc ~= 1 %ci sono dati riferiti all'ultimo mese/periodo di interesse
                DataPlot = [BatTemp(:,1) BatTemp(:,2)];
                % sistemo date, batteria e temperatura
                [rD,~] = size(DataPlot);
                T = [cell2mat(DataPlot(:,1)) repmat(' ', [rD,1]) cell2mat(DataPlot(:,2))];
                Date = datenum(T);
                Batteria = cell2mat(BatTemp(:,5));
                Temperatura = cell2mat(BatTemp(:,6));
                
                % testo introduttivo
                testoB1 = Paragraph(['I valori di tensione di alimentazione del GMUX registrati durante il periodo '...
                    'di monitoraggio sono riportati di seguito. Il corretto funzionamento del sistema '...
                    char(232) ' assicurato per una carica superiore a 12 V. L''ultimo dato disponibile ' char(232) ' pari '...
                    'a ' num2str(Batteria(end,1)) ' V.']);
                testoB2 = Paragraph(['Il GMUX integra al proprio interno un termometro '...
                    'per monitorate la temperatura di esercizio ed identificare eventuali '...
                    'anomalie. I dati di temperatura registrati sono riportati di seguito.']);
                testoB1.HAlign = 'justify';
                testoB2.HAlign = 'justify';
                                
                % grafico batteria
                figure(19)
                plot(Date,Batteria);
                hold on
                title('Batteria e Temperatura del GMUX');
                xlabel('Data [gg/mm/aaaa]');
                ylabel('Livello di Batteria [V]');
                ylim([floor(min(Batteria(:,1))) ceil(max(Batteria(:,1)))]);
                
                yyaxis right
                GMUX = plot(Date,Temperatura,':','LineWidth',1.1);
                ylim([floor(min(Temperatura(:,1))) ceil(max(Temperatura(:,1)))]);
                ylabel(['Temperatura [' char(176) 'C]']);
                set(gca,'YColor','k');
                str(1,1) = cellstr('Batteria');
                str(2,1) = cellstr('Temperatura');
                legend(str,'Location','northwest');
                h = gca;
                h.XAxis.MinorTick = 'on';
                datetick('x','dd/mm/yyyy','keepticks','keeplimits');
                xtickangle(20);
                grid on
                grid minor
                xlim([Date(1)-1 Date(end)+1]);
                
                TempName = char(strcat('Report',siteID,'-', contunit,'-GMUX.png'));
                saveas(GMUX,TempName);
                ChartGMUX = Image(TempName);
                ChartGMUX.Style = {Height('8cm'),HAlign('center')};
                if Batteria(end,1) >= 12.5
                    TempName = char(strcat('B_13.jpg'));
                elseif Batteria(end,1) >= 12
                    TempName = char(strcat('B_12.jpg'));
                elseif Batteria(end,1) >= 11.3
                    TempName = char(strcat('B_115.jpg'));
                elseif Batteria(end,1) >= 10.5
                    TempName = char(strcat('B_11.jpg'));
                else
                    TempName = char(strcat('B_10.jpg'));
                end
                Batt = Image(TempName);
                Batt.Style = {Height('4cm'),HAlign('center')};
                
                lot = Table({ChartGMUX, Batt});
                lot.TableEntriesStyle = {HAlign('center'),VAlign('middle')};
                lot.Style = {ResizeToFitContents(false),Width("100%")};
                grps(1) = TableColSpecGroup;
                grps(1).Span = 2;
                specs(1) = TableColSpec;
                specs(1).Span = 1;
                specs(1).Style = {Width("80%")};
                specs(2) = TableColSpec;
                specs(2).Span = 1;
                specs(2).Style = {Width("20%")};
                grps(1).ColSpecs = specs;
                lot.ColSpecGroups = grps;
                
                lot_cap = Paragraph(['Fig. ' num2str(FIG) ' - Livello di carica della batteria e temperatura del '...
                    'GMUX registrati durante il periodo di riferimento']);
                FIG = FIG+1;
                lot_cap.Style = {HAlign('center'),FontSize(Font_caption),Italic(1),Color('midnightblue')};
                Batt = Section();
                sezBATT = Heading3('GMUX - Batteria e Temperatura');
                sezBATT.Style = {FontSize(Font_tools),Bold(1),Italic(1)};
                Batt.Title = sezBATT;
                add(DT,sezBATT);
                add(DT,testoB1);
                add(DT,testoB2);
                add(DT,lot);
                add(DT,lot_cap);
                add(DT,br);
                close(figure(19));
                
                if activeEN == 1
                    testoB1 = Paragraph(['The following chart reports the GMUX battery level trend recorded '...
                        'during the reference time period. '...
                        'The correct functioning of the data acquisition system is guaranteed for a '...
                        'minimum level of 12 V. The last available data is equal to ' num2str(Batteria(end,1)) ' V.']);
                    testoB2 = Paragraph(['GMUX equips also a thermometer that allows the monitoring '...
                        'of the working temperature and the identification of eventual malfunctioning. The same '...
                        'chart displays also temperature data recorded by the multiplexer.']);
                    testoB1.HAlign = 'justify';
                    testoB2.HAlign = 'justify';
                    
                     % grafico batteria
                     figure(19)
                     plot(Date,Batteria);
                     hold on
                     title('GMUX battery level and temperature');
                     xlabel('Date [dd/mm/yyyy]');
                     ylabel('Battery Level [V]');
                     ylim([floor(min(Batteria(:,1))) ceil(max(Batteria(:,1)))]);
                     
                     yyaxis right
                     GMUX = plot(Date,Temperatura,':','LineWidth',1.1);
                     ylim([floor(min(Temperatura(:,1))) ceil(max(Temperatura(:,1)))]);
                     ylabel(['Temperature [' char(176) 'C]']);
                     set(gca,'YColor','k');
                     str(1,1) = cellstr('Battery');
                     str(2,1) = cellstr('Temperature');
                     legend(str,'Location','northwest');
                     h = gca;
                     h.XAxis.MinorTick = 'on';
                     datetick('x','dd/mm/yyyy','keepticks','keeplimits');
                     xtickangle(20);
                     grid on
                     grid minor
                     xlim([Date(1)-1 Date(end)+1]);
                     
                     TempName = char(strcat('Report',siteID,'-', contunit,'-GMUX_ENG.png'));
                     saveas(GMUX,TempName);
                     ChartGMUX = Image(TempName);
                     ChartGMUX.Style = {Height('8cm'),HAlign('center')};
                     Batt = Image(TempNameB);
                     Batt.Style = {Height('4cm'),HAlign('center')};
                     
                     lot = Table({ChartGMUX, Batt});
                     lot.TableEntriesStyle = {HAlign('center'),VAlign('middle')};
                     lot.Style = {ResizeToFitContents(false),Width("100%")};
                     grps(1) = TableColSpecGroup;
                     grps(1).Span = 2;
                     specs(1) = TableColSpec;
                     specs(1).Span = 1;
                     specs(1).Style = {Width("80%")};
                     specs(2) = TableColSpec;
                     specs(2).Span = 1;
                     specs(2).Style = {Width("20%")};
                     grps(1).ColSpecs = specs;
                     lot.ColSpecGroups = grps;
                     
                     lot_cap = Paragraph(['Fig. ' num2str(FIG_ENG) ' - Battery level and temperature recorded '...
                         'by the GMUX during the reference time period']);
                     FIG_ENG = FIG_ENG+1;
                     lot_cap.Style = {HAlign('center'),FontSize(Font_caption),Italic(1),Color('midnightblue')};
                     Batt_ENG = Section();
                     sezBATT_ENG = Heading3('GMUX - Battery and temperature');
                     sezBATT_ENG.Style = {FontSize(Font_tools),Bold(1),Italic(1)};
                     Batt_ENG.Title = sezBATT_ENG;
                     add(DT_ENG,sezBATT_ENG);
                     add(DT_ENG,testoB1);
                     add(DT_ENG,testoB2);
                     add(DT_ENG,lot);
                     add(DT_ENG,lot_cap);
                     add(DT_ENG,br);
                     close(figure(19));
                end
                battANALOG = 1;
            end
        end
     end
     
     sezLL = Heading3('Load Link');
     sezLL.Style = {FontSize(Font_tools),Bold(1),Italic(1)};
     LL = Section();
     LL.Title = sezLL;
     add(DT,sezLL);
     if activeEN == 1
         add(DT_ENG,sezLL);
     end
     
     for ld = 1:rLL(m,1)
         NodeNum = num2str(NodoLoadLink(ld,m));
         comando = ['select EventDate, EventTime, load_value from ElabDataView where EventDate >= ''' ...
             datarif ''' and  ToolNameID = ''' char(toolrif) ''' and UnitName = ''' char(unitrif) ...
             ''' and NodeNum = ''' NodeNum ''' '];
         curs = exec(conn,comando);
         curs = fetch(curs);
         Dati = curs.Data;
         % Modifico il formato di data e ora
         [rD,rC] = size(Dati);
         if rC ~= 1
             T = [cell2mat(Dati(:,1)) repmat(' ', [rD,1]) cell2mat(Dati(:,2))];
             Date = datenum(T); % Data
             carico = cell2mat(Dati(:,3)); % carico cella
             var_carico = carico-carico(1); % variazione carico
             
             % grafico carico
             figure(5);
             load = plot(Date,var_carico);
             title(['Variazione di Carico - Nodo numero ' NodeNum '']);
             xlabel('Data [gg/mm/aaaa]');
             ylabel('Variazione di carico [kN]');
             if strcmp(char(colonna4(m+1,1)),'Analog Array') == 1 % cella Analog Link
                 if max(var_carico) < 15 && min(var_carico) > -15
                     ylim([-15 15]);
                 elseif max(var_carico) > 15 && min(var_carico) > -15
                     ylim([-15 inf+1]);
                elseif max(var_carico) < 15 && min(var_carico) < -15
                    ylim([-inf-1 15]);
                end
            else % cella RSN
                if max(var_carico) < 10 && min(var_carico) > -10
                    ylim([-10 10]);
                elseif max(var_carico) > 10 && min(var_carico) > -10
                    ylim([-10 inf+1]);
                elseif max(var_carico) < 20 && min(var_carico) < -10
                    ylim([-inf-1 10]);
                end
            end
            h = gca;
            h.XAxis.MinorTick = 'on';
            datetick('x','dd/mm/yyyy','keepticks','keeplimits');
            xtickangle(20);
            grid on
            grid minor
            
            hold off
            
            TempName = char(strcat('Report',siteID,'-', char(toolrif),'-CellaCarico', NodeNum, '.png'));
            saveas(load,TempName);
            ChartLL = Image(TempName);
            ChartLL.Style = {Height('7.3cm'),HAlign('center')};
            ChartLL_cap = Paragraph(['Fig. ' num2str(FIG) ' - Variazione di carico'...
                ' registrato dalla cella di carico, sensore numero ' NodeNum...
                ', nel periodo temporale di riferimento']);
            FIG = FIG+1;
            ChartLL_cap.Style = {HAlign('center'),FontSize(Font_caption),Italic(1),Color('midnightblue')};
            
            testo = Paragraph(['Nel grafico seguente sono rappresentati i dati relativi '...
                'alla variazione di carico (in kN) registrata dai sensori appartenenti all''Analog Array.']);
            testo2 = Paragraph(['Durante il periodo temporale di riferimento, il nodo numero ' NodeNum ...
                ' ha rilevato una massima variazione di carico pari a '...
                num2str(round(max(abs(var_carico)),2), '%0.2f') ' kN, mentre il valore di '...
                'massimo carico assoluto ' char(232) ' pari a ' num2str(round(max(carico),2), '%0.2f') ' kN.' ]);
            testo.HAlign = 'justify';
            testo2.HAlign = 'justify';
            if ld == 1
                add(DT,testo);
            end
            add(DT,testo2);
            add(DT,ChartLL);
            add(DT,ChartLL_cap);
            if ld == rLL(m,1)
                add(DT,br);
            end
            close(figure(5));
            
            if activeEN == 1
                % grafico carico
                figure(5);
                load = plot(Date,var_carico);
                title(['Load variation - Node number ' NodeNum '']);
                xlabel('Date [dd/mm/yyyy]');
                ylabel('Load variation [kN]');
                if strcmp(char(colonna4(m+1,1)),'Analog Array') == 1 % cella Analog Link
                    if max(var_carico) < 15 && min(var_carico) > -15
                        ylim([-15 15]);
                    elseif max(var_carico) > 15 && min(var_carico) > -15
                        ylim([-15 inf+1]);
                    elseif max(var_carico) < 15 && min(var_carico) < -15
                        ylim([-inf-1 15]);
                    end
                else % cella RSN
                    if max(var_carico) < 10 && min(var_carico) > -10
                        ylim([-10 10]);
                    elseif max(var_carico) > 10 && min(var_carico) > -10
                        ylim([-10 inf+1]);
                    elseif max(var_carico) < 20 && min(var_carico) < -10
                        ylim([-inf-1 10]);
                    end
                end
                h = gca;
                h.XAxis.MinorTick = 'on';
                datetick('x','dd/mm/yyyy','keepticks','keeplimits');
                xtickangle(20);
                grid on
                grid minor
                hold off
                
                TempName = char(strcat('Report',siteID,'-', char(toolrif),'-CellaCarico', NodeNum, '_ENG.png'));
                saveas(load,TempName);
                ChartLL = Image(TempName);
                ChartLL.Style = {Height('7.3cm'),HAlign('center')};
                ChartLL_cap = Paragraph(['Fig. ' num2str(FIG_ENG) ' - Load variation'...
                    ' recorded by the load cell, node number ' NodeNum...
                    ', during the reference monitoring period']);
                FIG_ENG = FIG_ENG+1;
                ChartLL_cap.Style = {HAlign('center'),FontSize(Font_caption),Italic(1),Color('midnightblue')};
                
                testo = Paragraph(['The following graph represents the load variations recorded by the sensors '...
                    'that compose the Analog Array.']);
                testo2 = Paragraph(['During the reference time period, node number ' NodeNum ...
                    ' highlighted a maximum load variations of '...
                    num2str(round(max(abs(var_carico)),2), '%0.2f') ' kN, while the maximum absolute load '...
                    'recorded is ' num2str(round(max(carico),2), '%0.2f') ' kN.' ]);
                testo.HAlign = 'justify';
                testo2.HAlign = 'justify';
                if ld == 1
                    add(DT_ENG,testo);
                end
                add(DT_ENG,testo2);
                add(DT_ENG,ChartLL);
                add(DT_ENG,ChartLL_cap);
                if ld == rLL(m,1)
                    add(DT_ENG,br);
                end
                close(figure(5));
            end
            
            % pulisco variabili da riutilizzare per catena successiva
            clear carico;
            clear var_carico;
        else
            if ATTIVA == 1
                testo = Paragraph('Non sono presenti dati relativi al periodo temporale considerato.');
                ATTIVA = 0;
                add(DT,testo);
                add(DT,br);
                if activeEN == 1
                    testo = Paragraph('No data available for the reference time period.');
                    add(DT_ENG,testo);
                    if m == 1
                        add(DT_ENG,br);
                    end
                end
            end
        end
    end
end

text = 'report_LL function executed correctly';
fprintf(fileID,fmt,text);
fclose(fileID);

end